#include "problem2.hpp"
#include <iostream>

using namespace pe::problem2;

Problem2::Problem2(const unsigned long long max) :
  _max(max),
  INIT_LOGGER("problem2")
{
  LOG_DEBUG("Created problem2 engine.");
}

unsigned long long Problem2::calc()
{
  unsigned long long sum, tmp = 1;
  current = 2;
  previous = 1;
  LOG_DEBUG("Dumping Fibonacci numbers: "<< previous);
  while (current < _max) {
	LOG_DEBUG(current);
	if (current % 2 == 0)
	  sum += current;
	tmp=current;
	current = current + previous;
	previous = tmp;
  }
  LOG_INFO("Found sum: "<<sum);
  return sum;
}
